#include <gtk/gtk.h>
#include "button_box.h"
#include "kmap_struct.h"
#include "cell_array_table.h"
#include "g_library.h"
#include "key_table_entry.h"
#include "window.h"

int connection=-1; /*globle variable*/
GtkWidget *get_button_box(void)
{
	GtkWidget *hbox;
	hbox=gtk_hbox_new(FALSE,2);
	GtkWidget *show, *reset;
	show=gtk_button_new_with_label("   Show   ");
	gtk_tooltips_set_tip(tooltips,show,"Display the output key",NULL);
	reset=gtk_button_new_with_label("   Reset   ");
	gtk_tooltips_set_tip(tooltips,reset,"Reset all kmap cells",NULL);
	gtk_box_pack_start(GTK_BOX(hbox),show,FALSE,FALSE,0);
	gtk_box_pack_end(GTK_BOX(hbox),reset,FALSE,FALSE,0);
	g_signal_connect(G_OBJECT(show),"clicked",G_CALLBACK(on_show_clicked),NULL);
	g_signal_connect(G_OBJECT(reset),"clicked",G_CALLBACK(on_reset_clicked),NULL);
	return hbox;
}

/*#################### Callback of reset button ######################*/
void on_reset_clicked(GtkWidget *button,gpointer user_data)
{
	int i,j;	
	for(i=0;i<=3;i++)
	{
		for(j=0;j<=3;j++)
		{
			gtk_button_set_label(GTK_BUTTON(button_array[i][j]),"0");
			cell_array[i][j].value='0';
			cell_array[i][j].real_value='0';
		}
	}
	gtk_entry_set_text(GTK_ENTRY(key_entry1),"");
	gtk_widget_hide(key_entry2);
	
	connection=-1;
	final_out[0]='\0';
	return;
}

/*##################### Call back for show button #########################*/
void on_show_clicked(GtkWidget *button,gpointer user_data)
{
	init_kmap();
	int i,j;
	gchar *label;
	for(i=0;i<=3;i++)
	{
		for(j=0;j<=3;j++)
		{
			label=g_strdup(gtk_button_get_label(GTK_BUTTON(button_array[i][j])));
			cell_array[i][j].value=*label;
			cell_array[i][j].real_value=*label;
		}
	}
	if(!chk_no_1())
		return;
	if(!chk_all_1s())
		return;
	chk_mk_octet();
	chk_mk_quad();
    chk_mk_pair();
    chk_mk_single();
	set_status_of_connection();
	set_output();
	g_free(label);
	return;
}
