#include <gtk/gtk.h>
#include "window.h"
#include "cell_array_table.h"
#include "kmap_struct.h"
#include "../config.h"
GtkWidget *kmap_table;
GtkWidget *button_array[4][4];

extern gchar * package_pixmaps_dir;

struct attach{
		guint left;
		guint right;
		guint top;
		guint bottom;
		const gchar *cell_no;
	};
	
struct attach attach_values[4][4]={
	{{1,2,1,2,"0"},{2,3,1,2,"4"},{3,4,1,2,"12"},{4,5,1,2,"8"}},
	{{1,2,2,3,"1"},{2,3,2,3,"5"},{3,4,2,3,"13"},{4,5,2,3,"9"}},
	{{1,2,3,4,"3"},{2,3,3,4,"7"},{3,4,3,4,"15"},{4,5,3,4,"11"}},
	{{1,2,4,5,"2"},{2,3,4,5,"6"},{3,4,4,5,"14"},{4,5,4,5,"10"}}
};


/*###################### creat cell array table ######################*/
GtkWidget *get_cell_array_table(void)
{
	kmap_table=gtk_table_new(5,5,FALSE);
	
	GtkWidget *top_label_b;
	GtkWidget *left_label_b;
	GtkWidget *pic_img;
	GtkWidget *none;
	
	
	gchar *filename;
				
#ifdef G_OS_WIN32
		filename=g_build_filename (package_pixmaps_dir, "rc.png", NULL);
#else
        filename=g_build_filename (PACKAGE_PIXMAPS_DIR, "rc.png", NULL);
#endif

    pic_img=gtk_image_new_from_file(filename);
    g_free(filename);
		
	top_label_b=gtk_button_new_with_label("A'B'  A'B  AB   AB'");
	gtk_button_set_relief(GTK_BUTTON(top_label_b),GTK_RELIEF_HALF);
	none=gtk_button_new();
	gtk_container_add(GTK_CONTAINER(none),pic_img);
	
	left_label_b=gtk_button_new_with_label("C'D'\n\nC'D\n\nCD\n\nCD'");
	gtk_button_set_relief(GTK_BUTTON(left_label_b),GTK_RELIEF_HALF);
	
	
	gtk_table_attach_defaults(GTK_TABLE(kmap_table),none,0,1,0,1);
	
	gtk_table_attach_defaults(GTK_TABLE(kmap_table),top_label_b,1,5,0,1);
	
	
	gtk_table_attach_defaults(GTK_TABLE(kmap_table),left_label_b,0,1,1,5);
	
	
	int i,j;	
	for(i=0;i<=3;i++)
	{
		for(j=0;j<=3;j++)
		{
			button_array[i][j]=gtk_button_new_with_label("0");
			g_signal_connect( G_OBJECT(button_array[i][j]), "clicked" ,G_CALLBACK(on_cell_button_clicked), &cell_array[i][j]);
			gtk_table_attach_defaults(GTK_TABLE(kmap_table),button_array[i][j],attach_values[i][j].left,
																		attach_values[i][j].right,
																		attach_values[i][j].top,
																		attach_values[i][j].bottom);
			gtk_tooltips_set_tip(tooltips,button_array[i][j],attach_values[i][j].cell_no,NULL);
			gtk_widget_set_size_request(button_array[i][j],27,27);
		}
	}
	
	
	return kmap_table;
	
}

/*############################ Call back of cell buttons ########################*/
void on_cell_button_clicked(GtkWidget *button, gpointer user_data)
{
	gchar *label;
	label=g_strdup(gtk_button_get_label(GTK_BUTTON(button)));
	//struct cell *cell_pointer=user_data;
	if(!g_ascii_strncasecmp(label,"0",1))
	{
		g_strlcpy(label,"1",2);
		gtk_button_set_label(GTK_BUTTON(button),label);
		g_free(label);
		return;
	}
	
	if(!g_ascii_strncasecmp(label,"1",1))
	{
		g_strlcpy(label,"X",2);
		gtk_button_set_label(GTK_BUTTON(button),label);
		g_free(label);
		return;
	}
	
	if(!g_ascii_strncasecmp(label,"X",1))
	{
		g_strlcpy(label,"0",2);
		gtk_button_set_label(GTK_BUTTON(button),label);
		g_free(label);
		return;
	}
		
}
