#include "kmap_struct.h"
#include "check_octet.h" 


static int find_position_row[4][2]={{3,1},{0,2},{1,3},{2,0}};
static int find_position_col[4][2]={{3,1},{0,2},{1,3},{2,0}};

/*################## Check octet. RETURNS 0 when found #######################*/
void check_octet(int row,int col) /*return 0 when successful*/
{
  int horzntl_ott_status,vertical_ott_status;
  horzntl_ott_status=chk_horzntl_ott(row,col);
	if(horzntl_ott_status==FOUND)
		return; 
	vertical_ott_status=chk_vertical_ott(row,col);
	if(vertical_ott_status==FOUND)
		return;
}



/*############ Checks horizontal octet. RETURNS 0 when found #####################*/
int chk_horzntl_ott(row,col)
{
	int result_chkrow_nzero,result_chkuprow,result_chkdnrow,upperrow,lowerrow;
  	int ott_status;
	upperrow=find_position_row[row][WANT_UPPER];
	lowerrow=find_position_row[row][WANT_LOWER];
	result_chkrow_nzero=chk_row_nzero(row,col);
  	if(result_chkrow_nzero==FOUND) /*If row elements are non zero then check for octet in LOWER or UPPER rows*/
  	{
		result_chkuprow=chk_row_nzero(upperrow,col);
		if(result_chkuprow==0) /*0 shows all elements of upper row contains both 1 and X*/
		{
			ott_status=mk_upper_ott(row,col);
			return ott_status;
		}
		else 
		{
			result_chkdnrow=chk_row_nzero(lowerrow,col);
			if(result_chkdnrow==0)/*If LOWER row has 1 and Xs make octet with lower*/
			{
				ott_status=mk_lower_ott(row,col);
				return ott_status;
			}
		 	else /*when LOWER row is not able to make octet. i.e. there is any 0: Octet not possible*/
		 	{
				 return N_FOUND;
		 	}			 
	 	}
 	}
	else /*when LOWER row is not able to make octet. i.e. there is any 0: Octet not possible*/
	{
		return N_FOUND;
	}
}  

/*############ Checks vertical octet. RETURNS 0 when found #####################*/
int chk_vertical_ott(row,col)
{
  int result_chkcol_nzero,result_chkleftcol,result_chkrightcol,leftcol,rightcol;
  int ott_status;
  rightcol=find_position_col[col][WANT_RIGHT];
	leftcol=find_position_col[col][WANT_LEFT];
    
  result_chkcol_nzero=chk_col_nzero(row,col);
  if(result_chkcol_nzero==FOUND) /*If col elements are non zero then check for octet in LEFT and RIGHT columns*/
  {
		result_chkleftcol=chk_col_nzero(row,leftcol);
			if(result_chkleftcol==0) /*If LEFT col elements are Nzeros, Make Octet with left column*/
	 	{
			ott_status=mk_left_ott(row,col);
			 return ott_status;
		}
		else
		{
			result_chkrightcol=chk_col_nzero(row,rightcol);
			if(result_chkrightcol==0)/*If RIGHT column has 1 and Xs make octet with right column*/
			{
				ott_status=mk_right_ott(row,col);
				return ott_status;
			}
			else /*OCTET NOT FOUND*/
			{
				return N_FOUND;
			}
		}
	}
	else/****************IF THE ROW HAS NOT ALL NON ZEROS:MEANS OCTET NOT FOUND*/
	{
		return N_FOUND;
	}
}



/*##################### Make Lower Octet #########################*/
int mk_lower_ott(row,col)
{
  connection++;
	save_key(row,col,LOWER,0); /*0 in place of vertical shows that we have to work with horizontal only*/
  store_cell_nums(row,col,LOWER,0);
	set_all_as_X(row,col,LOWER,0);
  set_status_active();
  return 0; 
}



/*##################### Make UPPER Octet #########################*/
int mk_upper_ott(row,col)
{
  connection++;
  save_key(row,col,UPPER,0); /*0 in place of vertical shows that we have to work with horizontal only*/
  store_cell_nums(row,col,UPPER,0);
	set_all_as_X(row,col,UPPER,0);
  set_status_active();
  return 0; 
}



/*##################### Make Left Octet #########################*/
int mk_left_ott(row,col)
{
  connection++;
  save_key(row,col,0,LEFT); /*0 in place of vertical shows that we have to work with horizontal only*/
  store_cell_nums(row,col,0,LEFT);
	set_all_as_X(row,col,0,LEFT);
	set_status_active();
  return 0; 
}




/*##################### Make Right Octet #########################*/
int mk_right_ott(row,col)
{
  connection++;
  save_key(row,col,0,RIGHT); /*0 in place of vertical shows that we have to work with horizontal only*/
  store_cell_nums(row,col,0,RIGHT);
	set_all_as_X(row,col,0,RIGHT);
  set_status_active();
  return 0; 
}





/*####################Save Key of Connection#########################*/
void save_key(int row,int col,int hozntal, int vertical)
{
  char *arr1,*arr2;
  char first, second;
  int new_row, new_col;
  arr1=malloc(4);
  arr2=malloc(4);
  if(hozntal!=0)
  {
		new_row=get_new_row(row,hozntal); /*get the another row of the hoz. octet other than in which 1 was found*/
		strcpy(arr1,cell_array[row][col].row_string);
		strcpy(arr2,cell_array[new_row][col].row_string);
  	first=*arr1;
	if(strchr(arr2,first)!=NULL)
  	{
		sprintf(out_array[connection].connection_output,"%c",first);
	}
  	else
  	{
		second=*(arr1+1);
		sprintf(out_array[connection].connection_output,"%c",second);
	}
  }
 	
  if(vertical!=0)
  {
		new_col=get_new_col(col,vertical);/*get the another colof the ver. octet other than in which 1 was found*/
		strcpy(arr1,cell_array[row][col].col_string);
  	strcpy(arr2,cell_array[row][new_col].col_string);
  	first=*arr1;
  	if(strchr(arr2,first)!=NULL)
  	{
			sprintf(out_array[connection].connection_output,"%c",first);
		}
  	else
  	{
			second=*(arr1+1);
			sprintf(out_array[connection].connection_output,"%c",second);
		}
  }
	return;
}



/*################## Set all 1 and Xs of Octet as X #####################*/
void set_all_as_X(int row,int col,int hozntal,int vertical)
{
	int new_row,new_col;
	if(hozntal!=0)
  {
		new_row=get_new_row(row,hozntal); /*get the another row of the hoz. octet other than in which 1 was found*/
		for(col=0;col<=3;col++)/*set col to 0 to get first column of row*/
		{
			cell_array[row][col].value='X';
		}
		for(col=0;col<=3;col++)
		{
			cell_array[new_row][col].value='X';
		}
	}
	if(vertical!=0)
  {
		new_col=get_new_col(col,vertical);/*get the another colof the ver. octet other than in which 1 was found*/
		for(row=0;row<=3;row++)/*set row to 0 to get first element of column*/
		{
			cell_array[row][col].value='X';
		}
		for(row=0;row<=3;row++)
		{
			cell_array[row][new_col].value='X';
		}
	}
	return;
}


/*############ Store all cell numbers of octet in the array cell_number_string #########*/
void store_cell_nums(int row,int col, int hozntal, int vertical)
{
	int new_row,new_col,arr_count;
	if(hozntal!=0)
  {
		new_row=get_new_row(row,hozntal); /*get the another row of the hoz. octet other than in which 1 was found*/
		/*This loop stores the cell no of real row into array*/
		/*real row is that row in which first 1 was  found adjacent to which there is new row*/
		for(col=0,arr_count=0;col<=3;col++)
		{	
			if(cell_array[row][col].real_value=='1')
			{
				out_array[connection].cell_num_string[arr_count]=cell_array[row][col].cell_num;
				arr_count++;
			}
		}
		/*This loop stores the cell nos of new_row into array*/
		for(col=0,arr_count;col<=3;col++)
		{
			if(cell_array[new_row][col].real_value=='1')
			{
				out_array[connection].cell_num_string[arr_count]=cell_array[new_row][col].cell_num;
				arr_count++;
			}
		}
		out_array[connection].cell_num_string[arr_count]='\0';
	}
	if(vertical!=0)
  {
		new_col=get_new_col(col,vertical);/*get the another colof the ver. octet other than in which 1 was found*/
		for(row=0,arr_count=0;row<=3;row++)/*set row to 0 to get first element of column*/
		{
			if(cell_array[row][col].real_value=='1')
			{
				out_array[connection].cell_num_string[arr_count]=cell_array[row][col].cell_num;
				arr_count++;
			}
		}
		
		for(row=0,arr_count;row<=3;row++)
		{
			if(cell_array[row][new_col].real_value=='1')
			{
				out_array[connection].cell_num_string[arr_count]=cell_array[row][new_col].cell_num;
				arr_count++;
			}
		}
		out_array[connection].cell_num_string[arr_count]='\0';
	}
	return;
}
