#include "kmap_struct.h"
#include "check_pair.h"
#include "pair_lib.h"



void check_pair(int row,int col)
{
	int left_status,up_status,right_status,down_status,pair_status,status;
	
	if((status=check_pair_with_1(row,col))==0)
		return;
	if((left_status=chk_left_pair(row,col))==FOUND)
	{
		pair_status=mk_left_pair(row,col);
		return;
	}
	if((up_status=chk_up_pair(row,col))==FOUND)
	{
		pair_status=mk_up_pair(row,col);
		return;
	}
	if((right_status=chk_right_pair(row,col))==FOUND)
	{
		pair_status=mk_right_pair(row,col);
		return;
	}
	if((down_status=chk_down_pair(row,col))==FOUND)
	{
		pair_status=mk_down_pair(row,col);
		return;
	}
	return;
}


/*################### Checks the left column for pair #####################*/
int chk_left_pair(int row,int col)
{
	int new_col;
	new_col=get_new_col(col,LEFT);
	if((cell_array[row][new_col].value=='1')||(cell_array[row][new_col].value=='X'))
		return FOUND;
	return N_FOUND;
}

/*################### Checks the right column  for pair #####################*/
int chk_right_pair(int row,int col)
{
	int new_col;
	new_col=get_new_col(col,RIGHT);
	if((cell_array[row][new_col].value=='1')||(cell_array[row][new_col].value=='X'))
		return FOUND;
	return N_FOUND;
}


/*################### Checks the upper row  for pair #####################*/
int chk_up_pair(int row,int col)
{
	int new_row;
	new_row=get_new_row(row,UPPER);
	if((cell_array[new_row][col].value=='1')||(cell_array[new_row][col].value=='X'))
		return FOUND;
	return N_FOUND;
}

/*################### Checks the lower row  for pair #####################*/
int chk_down_pair(int row,int col)
{
	int new_row;
	new_row=get_new_row(row,LOWER);
	if((cell_array[new_row][col].value=='1')||(cell_array[new_row][col].value=='X'))
		return FOUND;
	return N_FOUND;
}

/*####################### makes left pair ############################*/
int mk_left_pair(int row,int col)
{
	connection++;
	save_key_lf(row,col);
	set_X_lf(row,col);
	save_cellno_lf(row,col);
	set_status_active();
	return FOUND;
}


/*####################### makes right pair ############################*/
int mk_right_pair(int row,int col)
{
	connection++;
	save_key_rt(row,col);
	set_X_rt(row,col);
	save_cellno_rt(row,col);
	set_status_active();
	return FOUND;
}


/*####################### makes upper pair ############################*/
int mk_up_pair(int row,int col)
{
	connection++;
	save_key_up(row,col);
	set_X_up(row,col);
	save_cellno_up(row,col);
	set_status_active();
	return FOUND;
}


/*####################### makes lower pair ############################*/
int mk_down_pair(int row,int col)
{
	connection++;
	save_key_dn(row,col);
	set_X_dn(row,col);
	save_cellno_dn(row,col);
	set_status_active();
	return FOUND;
}
