#include "kmap_struct.h"
#include "check_quad.h"
#include "quad_lib.h"
#include "g_library.h"






/*################ CHECKS THE QUAD AND RETURNS THE STATUS ##############*/
void check_quad(int row,int col)
{
	int row_status,col_status,left_down_status,left_up_status;
	int right_down_status,right_up_status,quad_status;
	
	if((row_status=chk_row_nzero(row,col))==FOUND)
	{
		quad_status=mk_hozntal_quad(row,col);
		return;
	}
	if((col_status=chk_col_nzero(row,col))==FOUND)
	{
		quad_status=mk_vertical_quad(row,col);
		return;
	}
	if((left_down_status=chk_lf_dn_quad(row,col))==FOUND)
	{
		quad_status=mk_lf_dn_quad(row,col);
		return;
	}
	if((left_up_status=chk_lf_up_quad(row,col))==0)
	{
		quad_status=mk_lf_up_quad(row,col);
		return;
	}
	if((right_down_status=chk_rt_dn_quad(row,col))==0)
	{
		quad_status=mk_rt_dn_quad(row,col);
		return;
	}
	if((right_up_status=chk_rt_up_quad(row,col))==0)
	{
		quad_status=mk_rt_up_quad(row,col);
		return;
	}
	return;
}


int mk_hozntal_quad(int row,int col)
{
	connection++;
	save_key_hz_vrt(row,col,HZNTL);
	save_cellno_hz_vrt(row,col,HZNTL);
	set_all_x_hz_vr(row,col,HZNTL);
	set_status_active();
	return 0;
}


int mk_vertical_quad(int row,int col)
{
	connection++;
	save_key_hz_vrt(row,col,VRTCL);
	save_cellno_hz_vrt(row,col,VRTCL);
	set_all_x_hz_vr(row,col,VRTCL);
	set_status_active();
	return 0;
}


int mk_lf_dn_quad(int row,int col)
{
	connection++;
	save_key_lf_dn(row,col);
	save_cellno_lf_dn(row,col);
	set_all_x_lf_dn(row,col);
	set_status_active();
	return 0;
}

int mk_lf_up_quad(int row,int col)
{
	connection++;
	save_key_lf_up(row,col);
	save_cellno_lf_up(row,col);
	set_all_x_lf_up(row,col);
	set_status_active();
	
	return 0;
}
int mk_rt_up_quad(int row,int col)
{
	connection++;
	save_key_rt_up(row,col);
	save_cellno_rt_up(row,col);
	set_all_x_rt_up(row,col);
	set_status_active();
	return 0;
}

int mk_rt_dn_quad(int row,int col)
{
	connection++;
	save_key_rt_dn(row,col);
	save_cellno_rt_dn(row,col);
	set_all_x_rt_dn(row,col);
	set_status_active();
	return 0;
}


/*######################## Check left down quad ########################*/
int chk_lf_dn_quad(int row,int col)
{
	int new_row,new_col;
	new_row=get_new_row(row,LOWER);
	new_col=get_new_col(col,LEFT);
	if(((cell_array[row][col].value=='1')||(cell_array[row][col].value=='X'))
		&&((cell_array[row][new_col].value=='1')||(cell_array[row][new_col].value=='X'))
		&&((cell_array[new_row][new_col].value=='1')||(cell_array[new_row][new_col].value=='X'))
		&&((cell_array[new_row][col].value=='1')||(cell_array[new_row][col].value=='X')))
		return FOUND;
	else
		return N_FOUND;
}



/*######################## Check left up quad ########################*/
int chk_lf_up_quad(int row,int col)
{
	int new_row,new_col;
	new_row=get_new_row(row,UPPER);
	new_col=get_new_col(col,LEFT);
	if(((cell_array[row][col].value=='1')||(cell_array[row][col].value=='X'))
		&&((cell_array[row][new_col].value=='1')||(cell_array[row][new_col].value=='X'))
		&&((cell_array[new_row][new_col].value=='1')||(cell_array[new_row][new_col].value=='X'))
		&&((cell_array[new_row][col].value=='1')||(cell_array[new_row][col].value=='X')))
		return FOUND;
	else
		return N_FOUND;
}

/*######################## Check right up quad ########################*/
int chk_rt_up_quad(int row,int col)
{
	int new_row,new_col;
	new_row=get_new_row(row,UPPER);
	new_col=get_new_col(col,RIGHT);
	if(((cell_array[row][col].value=='1')||(cell_array[row][col].value=='X'))
		&&((cell_array[row][new_col].value=='1')||(cell_array[row][new_col].value=='X'))
		&&((cell_array[new_row][new_col].value=='1')||(cell_array[new_row][new_col].value=='X'))
		&&((cell_array[new_row][col].value=='1')||(cell_array[new_row][col].value=='X')))
		return FOUND;
	else
		return N_FOUND;
}

/*######################## Check right down quad ########################*/
int chk_rt_dn_quad(int row,int col)
{
	int new_row,new_col;
	new_row=get_new_row(row,LOWER);
	new_col=get_new_col(col,RIGHT);
	
	if(((cell_array[row][col].value=='1')||(cell_array[row][col].value=='X'))
		&&((cell_array[row][new_col].value=='1')||(cell_array[row][new_col].value=='X'))
		&&((cell_array[new_row][new_col].value=='1')||(cell_array[new_row][new_col].value=='X'))
		&&((cell_array[new_row][col].value=='1')||(cell_array[new_row][col].value=='X')))
		return FOUND;
	else
		return N_FOUND;
}
