#include <gtk/gtk.h>
#include "kmap_struct.h"
#include "g_library.h"
#include "key_table_entry.h"
#include "check_octet.h"
#include "check_quad.h"
#include "check_pair.h"
#include "mk_single.h"


/*********************** Checks the whole kmap table ,If there is no 1 Kmap, key set to 0***********************/
int chk_no_1(void)
{
	int i,j;
	for(i=0;i<=3;i++)
	{
		for(j=0;j<=3;j++)
		{
			if(cell_array[i][j].value!='1');
			else
				return 1;/*If any 1 found return 1*/
		}
	}
	gtk_entry_set_text(GTK_ENTRY(key_entry1),"0");
	return 0;
}


/******************** Checks for all elements as 1 or X ****************/
int chk_all_1s(void)
{
	int i,j;
	for(i=0;i<=3;i++)
	{
		for(j=0;j<=3;j++)
		{
			if((cell_array[i][j].value=='1')||(cell_array[i][j].value=='X'));
			else
				return 1; /*Return 1 when any Zero appers in the Kmap Table*/
		}
	}
	gtk_entry_set_text(GTK_ENTRY(key_entry1),"1");
	return 0;
}

/*################# checks all octet possibilities in Kmap #############################*/
void chk_mk_octet(void)
{
	int i,j;
	for(i=0;i<=3;i++)
	{
		for(j=0;j<=3;j++)
		{
			if(cell_array[i][j].value=='1')
			{
				check_octet(i,j);
			}
		}
	}
	return;
}

/*########## This function will Set status of connection ##########################*/
/*Logic:Take a character from the string of cell numbers(particular connection) and search it in all connection's cell_num_string
   by calling function find_char_in_str(). If each character is found in the different connections, i.e. the length of string of cell 
  numbers(particular connection)becomes equal to the counter result INACTIVATE that connection */
void set_status_of_connection(void)
{
	int i,j,result1,result=0;
	size_t length;
	for(i=0;i<=connection;i++)
	{
		result1=0;
		length=strlen(out_array[i].cell_num_string);
		for(j=0;j<length;j++)
		{
			result=find_char_in_str(i,out_array[i].cell_num_string[j]);
			result1=result1+result;
		}
		if(result1==length)
			out_array[i].status=INACTIVE;
		else
			out_array[i].status=ACTIVE;
	}
	return;
}


/*################# checks all quad possibilities in Kmap ############################*/
void chk_mk_quad(void)
{
	int i,j;
	for(i=0;i<=3;i++)
	{
		for(j=0;j<=3;j++)
		{
			if(cell_array[i][j].value=='1')
			{
				check_quad(i,j);
			}
		}
	}
	return;
}

/*############# MATCH CHARCTER IN out_array #########################*/
int find_char_in_str(int conn_no_of_findthis,char find_this)
{
	int i,found=0;
	for(i=0;i<=connection;i++)
	{
		if(i!=conn_no_of_findthis)
		{
			if(strchr(out_array[i].cell_num_string,find_this)!=NULL)
			{
				found++;
				return found;
			}
		}
		else
		{
			continue;
		}
	}
	return found;
}


/*################# checks all pair possibilities in Kmap ############################*/
void chk_mk_pair(void)
{
	int i,j;
	for(i=0;i<=3;i++)
	{
		for(j=0;j<=3;j++)
		{
			if(cell_array[i][j].value=='1')
			{
				check_pair(i,j);
			}
		}
	}
	return;
}

/*################# checks and make all singles in Kmap #############################*/
void chk_mk_single(void)
{
	int i,j;
	for(i=0;i<=3;i++)
	{
		for(j=0;j<=3;j++)
		{
			if(cell_array[i][j].value=='1')
			{
				mk_single(i,j);
			}
		}
	}
	return;
}

/*########### Checks whole row for non zeros.RETURNS 0 for non zeros #################*/
int chk_row_nzero(int row,int col)
{
  int i,j,check;
  i=row;
  j=col;
  check=0;
	/*No need to check for the element itself here because it is sure to be 1 and its right we have to check*/
  if(cell_array[row][col].value!='0')
	{
		for(;strcmp(cell_array[i][j].right->col_string,cell_array[row][col].col_string)!=0;j++)
		{
			if((cell_array[i][j].right->value=='1')||(cell_array[i][j].right->value=='X'))
	 		{
				check=0; /*check=0 confirms that the elements in row are non Zeros*/
				if(j==3)
				j=-1;
	 		}
	 		else
	 		{
				check=1; /*If all elements in row are not 1 loop will break and make check=1*/
				break;
	 		}
  		}
	}
	else
	{
		return N_FOUND;
	}
  return check;
}



/*########### Checks whole col for non zeros.RETURNS 0 for non zeros #################*/
int chk_col_nzero(int row,int col)
{
  int i,j,check;
  i=row;
  j=col;
  check=0;
	/*No need to check for the element itself here because it is sure 1 and its down we have to check*/
  if(cell_array[row][col].value!='0')
	{
		for(;strcmp(cell_array[i][j].down->row_string,cell_array[row][col].row_string)!=0;i++)
  	{
	 		if((cell_array[i][j].down->value=='1')||(cell_array[i][j].down->value=='X'))
	 		{
				check=0; /*check=0 confirms that the elements of column are non Zeros*/
				if(i==3)
				i=-1;
	 		}
	 		else
	 		{
				check=1; /*If all elements in col are not 1 loop will break and make check=1*/
				break;
	 		}
  		}
	}
	else
	{
		return N_FOUND;
	}
  return check;
}

/*################### Set status of connection ########################*/
void set_status_active()
{
	out_array[connection].status=ACTIVE;
	return;
}

/*##################### Finds value for variable new_row  ##########################*/
int get_new_row(int row,int hozntal)
{
	int new_row=0;
	switch(hozntal)
	{
	 	case LOWER:
			if(row==3)
				new_row=0;
			else
				new_row=row+1;
	 			break;
		case UPPER:
			if(row==0)
				new_row=3;
			else
				new_row=row-1;
	  		break;
	}
	return new_row;
}
	

/*##################### Finds value for variable new_row  ##########################*/
int get_new_col(int col,int vertical)
{
	int new_col=0;
	switch(vertical)
		{
			case LEFT:
				if(col==0)
			 	new_col=3;
			 	else
					new_col=col-1;
			  break;
	   	case RIGHT:
				if(col==3)
					new_col=0;
				else
					new_col=col+1;
		  	break;
		}
	return new_col;
}

/*######################### Set the final Output ########################*/

void set_output(void)
{
	int i;
	char value_from_semi_final_out;
	strcpy(semi_final_out,"");
	for(i=0;i<=connection;i++)
	{
		if(out_array[i].status==ACTIVE)
		{
			if(i!=connection)
			strcat(out_array[i].connection_output,"+");
		}
	}
	
	for(i=0;i<=connection;i++)
	{
		if(out_array[i].status==ACTIVE)
		{
			strcat(semi_final_out,out_array[i].connection_output);
		}
	}
	strcpy(final_out,""); 
	i=0;
	while(semi_final_out[i]!='\0')
	{
		value_from_semi_final_out=semi_final_out[i];
		switch(value_from_semi_final_out)
		{
			case 'a':
				strcat(final_out,"A'");
				break;
			case 'b':
				strcat(final_out,"B'");
				break;
			case 'c':
				strcat(final_out,"C'");
				break;
			case 'd':
				strcat(final_out,"D'");
				break;
			case 'A':
				strcat(final_out,"A");
				break;
			case 'B':
				strcat(final_out,"B");
				break;
			case 'C':
				strcat(final_out,"C");
				break;
			case 'D':
				strcat(final_out,"D");
				break;
			case '+':
				strcat(final_out,"+");
				break;
		}
		i++;
	}
	int final_length,x,k;
	final_length=x=0;
	final_length=strlen(final_out);
	if(final_length>32)
	{
		x=31;
		while(final_out[x]!='+')
		{
			x--;
		}
		char *temp, *entry2;
		temp=malloc(2);
		entry2=malloc(33);
		strcpy(temp,"");
		strcpy(entry2,"");
		for(k=x;final_out[k]!='\0';k++)
		{
			sprintf(temp,"%c",final_out[k]);
			strcat(entry2,temp);
		}
		final_out[x]='\0';
		free(temp);
		gtk_widget_show(key_entry2);
		gtk_entry_set_text(GTK_ENTRY(key_entry2),entry2);
	}
	else
	{
		gtk_widget_hide(key_entry2);	
	}
	gtk_entry_set_text(GTK_ENTRY(key_entry1),final_out);
	
	
	connection=-1;/*after showing the values set initialize them for further usage*/
	semi_final_out[0]='\0';
	strcpy(final_out,"");
	for(i=0;i<=20;i++)
	{
		out_array[i].connection_output[0]='\0';
	}
	return;
}
