#include <gtk/gtk.h>
#include "menu_bar.h"
#include "window.h"
//#include "../devcpp/config.h"



/*################### Create item factory entry for menu ################*/
GtkItemFactoryEntry kmap_menubar_items[ ]  =
{
	{"/_File", NULL , 0 , 0 , "<Branch>" },
	{"/File/_Close","<control>Q", quit_from_main , 0, "<StockItem>", GTK_STOCK_QUIT },
	{"/_Help", NULL , 0 , 0 , "<Branch>" },
	{"/Help/_About","<control>A",help_developer, 0, "<StockItem>", GTK_STOCK_ABOUT },
};

GtkWidget *get_menubar(void)
{
	GtkAccelGroup *kmap_accel_group;
    GtkItemFactory *kmap_item_factory;
	GtkWidget *menubar;
	
	/*create main window's accelgroup*/
	kmap_accel_group=gtk_accel_group_new();
	gtk_window_add_accel_group(GTK_WINDOW (main_window), kmap_accel_group);
	g_object_unref(kmap_accel_group);
	
	/*create the menubar item factory and return menubar widget*/
	
	kmap_item_factory=gtk_item_factory_new(GTK_TYPE_MENU_BAR,
											"<main>",kmap_accel_group);
	gtk_item_factory_create_items ( kmap_item_factory, G_N_ELEMENTS ( kmap_menubar_items ),
									kmap_menubar_items, main_window );
	menubar=gtk_item_factory_get_widget (kmap_item_factory, "<main>");
	
	return menubar;
}



void help_developer(void)
{
	
	GtkWidget *about_dialog,*a_label,*gsim_label,*mean_label,*copy_label,*gsim_image;

	about_dialog=gtk_about_dialog_new();
	//gtk_widget_set_parent(about_dialog,gsim_appwindow);
	gchar *authers[3]={ "Hemant Kumar<hemantkumar1982@gmail.com>","Vinod Kumar Dahiya <dahiyavinod@gmail.com>",NULL};
	gchar *documenters[3]={ "Hemant Kumar<hemantkumar1982@gmail.com>","Vinod Kumar Dahiya <dahiyavinod@gmail.com>",NULL};
	
	gchar *label=
	"      This program is free software; you can redistribute it "
	"and/or modify it under the terms of the GNU General "
	"Public License as published by the Free Software "
	"Foundation; either version 2 of the License, or "
	"(at your option) any later version.\n"
	"      This program is distributed in the hope that it will "
	"be useful, but WITHOUT ANY WARRANTY; without even the "
	"implied warranty of MERCHANTABILITY or FITNESS FOR A "
	"PARTICULAR PURPOSE.  See the GNU General Public License "
	"for more details.\n"	
	"      You should have received a copy of the GNU General "
	"Public License along with this program; if not, write "
	"to the Free Software Foundation, Inc., 675 Mass Ave, "
	"Cambridge, MA 02139, USA.";
	
    gtk_about_dialog_set_name(GTK_ABOUT_DIALOG(about_dialog),"GKMap");
    gtk_about_dialog_set_version(GTK_ABOUT_DIALOG(about_dialog),"0.2");
    gtk_about_dialog_set_comments(GTK_ABOUT_DIALOG(about_dialog),"A Karnaugh map disclosure");
    gtk_about_dialog_set_copyright(GTK_ABOUT_DIALOG(about_dialog),"Hemant Kumar & Vinod Dahiya ");
    gtk_about_dialog_set_website(GTK_ABOUT_DIALOG(about_dialog),"http://sourceforge.net/projects/gkmap");
    gtk_about_dialog_set_website_label(GTK_ABOUT_DIALOG(about_dialog),"http://sourceforge.net/projects/gkmap");
    gtk_about_dialog_set_license(GTK_ABOUT_DIALOG(about_dialog),label);
    gtk_about_dialog_set_wrap_license(GTK_ABOUT_DIALOG(about_dialog),TRUE);
    gtk_about_dialog_set_documenters(GTK_ABOUT_DIALOG(about_dialog),documenters);
    gtk_about_dialog_set_authors(GTK_ABOUT_DIALOG(about_dialog),authers);
    
    
	gtk_dialog_run (GTK_DIALOG (about_dialog));
	gtk_widget_destroy(about_dialog);
}


void bugs(void)
{
	GtkWidget *a_dialog,*a_label;
	
	a_dialog=gtk_dialog_new_with_buttons("BUGS REPORT",GTK_WINDOW(main_window),GTK_DIALOG_DESTROY_WITH_PARENT,GTK_STOCK_OK,GTK_RESPONSE_NONE,NULL);
	a_label=gtk_label_new("   \n PLEASE REPORT BUGS AT :\n"
							"              e-mail: bugs@sinew.in\n");
	gtk_container_add(GTK_CONTAINER(GTK_DIALOG(a_dialog)->vbox),a_label);
	g_signal_connect(a_dialog,"response",G_CALLBACK(gtk_widget_destroy),a_dialog);
	gtk_widget_show_all(a_dialog);
	return;
}

void help_about(void)
{
	/*GtkWidget *about_dialog,*about_label,*kmap_image,*kmap_label,*copyright_label,*a_label;
	
	about_dialog=gtk_dialog_new_with_buttons("ABOUT",GTK_WINDOW(main_window),GTK_DIALOG_DESTROY_WITH_PARENT,GTK_STOCK_OK,GTK_RESPONSE_NONE,NULL);
	gtk_dialog_set_has_separator(GTK_DIALOG(about_dialog),FALSE);
	kmap_image=gtk_image_new_from_file(PACKAGE_PIXMAPS_DIR"/kmap.png");
	kmap_label=gtk_label_new("<span foreground=\"red\" font_desc=\"luxi sans bold 15\">Kmap Disclosure</span>");
	gtk_label_set_use_markup(GTK_LABEL(kmap_label),TRUE);
	//copyright_label=gtk_label_new("<span foreground=\"blue\" font_desc=\"luxi sans bold 8\">Copyright (c)  SINEW SOFTWARE SYSTEMS</span>");
	//gtk_label_set_use_markup(GTK_LABEL(copyright_label),TRUE);
	a_label=gtk_label_new("     _______________________________________________________     \n"); 
	about_label=gtk_label_new("    This is a simple Kmap Disclosure.    \n"
													  "    It is useful in solving the kmap problems very efficiently. You can    \n"
													  "    enter various cell element values by just clicking on buttons.  \n"
													  "    After setting the kmap cell elements, Click  'Show'  button to get the key.\n"
													);
	
	gtk_container_add(GTK_CONTAINER(GTK_DIALOG(about_dialog)->vbox),kmap_image);
	gtk_container_add(GTK_CONTAINER(GTK_DIALOG(about_dialog)->vbox),kmap_label);
	//gtk_container_add(GTK_CONTAINER(GTK_DIALOG(about_dialog)->vbox),copyright_label);
	gtk_container_add(GTK_CONTAINER(GTK_DIALOG(about_dialog)->vbox),a_label);
	gtk_container_add(GTK_CONTAINER(GTK_DIALOG(about_dialog)->vbox),about_label);
	g_signal_connect(about_dialog,"response",G_CALLBACK(gtk_widget_destroy),about_dialog);
	gtk_widget_show_all(about_dialog);*/
	return;
}


void license(void)
{
	/*GtkWidget *about_dialog,*about_label,*gsysinfo_image,*gsysinfo_label,*a_label;
	
	about_dialog=gtk_dialog_new_with_buttons("LICENSE",GTK_WINDOW(main_window),GTK_DIALOG_DESTROY_WITH_PARENT,GTK_STOCK_OK,GTK_RESPONSE_NONE,NULL);
	gsysinfo_image=gtk_image_new_from_file(PACKAGE_PIXMAPS_DIR"/license_info.png");
	gsysinfo_label=gtk_label_new("<span foreground=\"red\" font_desc=\"luxi sans bold 15\">LICENSE</span>");
	gtk_label_set_use_markup(GTK_LABEL(gsysinfo_label),TRUE);
	

	a_label=gtk_label_new("     _______________________________________________________     \n"); 
	
	about_label=gtk_label_new("<span font_desc=\"luxi sans bold 9\" >This program is free software; you can redistribute it and/or  \n"  
							  "modify it under the termsof the GNU General  Public License \n"  
							  "as published by the Free Software Foundation; either version  \n"
							  "2  of the License, or  (at your option)  any later version. This   \n"  
							  "program is distributed with the hope that it will be useful, but  \n" 
							  "WITHOUT  ANY  WARRANTY; without  even  the implied  \n" 
							  "warranty  of  MERCHANTABILITY  or  FITNESS FOR A  \n"
							  "PARTICULAR  PURPOSE. See  the  GNU  General Public     \n"
							  "License for more details.You should have received a copy of    \n"
							  "the GNU GPL along with this program; if  not, write to  the   \n"
							  "Free Software Foundation, Inc.,675 Mass Ave, Cambridge, \n"
							  "MA 02139, USA.\n</span>"
); 	
	gtk_label_set_use_markup(GTK_LABEL(about_label),TRUE);
	gtk_container_add(GTK_CONTAINER(GTK_DIALOG(about_dialog)->vbox),gsysinfo_image);
	gtk_container_add(GTK_CONTAINER(GTK_DIALOG(about_dialog)->vbox),gsysinfo_label);
	gtk_container_add(GTK_CONTAINER(GTK_DIALOG(about_dialog)->vbox),a_label);
	gtk_container_add(GTK_CONTAINER(GTK_DIALOG(about_dialog)->vbox),about_label);
	g_signal_connect(about_dialog,"response",G_CALLBACK(gtk_widget_destroy),about_dialog);
	gtk_widget_show_all(about_dialog);*/
}
