#include "kmap_struct.h"
#include "pair_lib.h"
#include "g_library.h"



/*######################## Checks pair with 1 #########################*/
int check_pair_with_1(int row,int col)
{
	int new_col_left,new_col_right,new_row_down,new_row_up;
	new_col_left=get_new_col(col,LEFT);
	new_col_right=get_new_col(col,RIGHT);
	new_row_up=get_new_row(row,UPPER);
	new_row_down=get_new_row(row,LOWER);
	if(cell_array[row][new_col_left].value=='1')
	{
		mk_left_pair(row,col);
		return 0;
	}
	if(cell_array[row][new_col_right].value=='1')
	{
		mk_right_pair(row,col);
		return 0;
	}
	if(cell_array[new_row_up][col].value=='1')
	{
		mk_up_pair(row,col);
		return 0;
	}
	if(cell_array[new_row_down][col].value=='1')
	{
		mk_down_pair(row,col);
		return 0;
	}
	return 1;
}
	
/*#################### Saves the key of left pair ########################*/
void save_key_lf(int row,int col)
{
	int new_col;
	char firstsame_col,secondsame_col;
	char temp[2];
	new_col=get_new_col(col,LEFT);
	firstsame_col=cell_array[row][col].col_string[0];
	secondsame_col=cell_array[row][col].col_string[1];
	strcat(out_array[connection].connection_output,cell_array[row][col].row_string);
	if(strchr(cell_array[row][new_col].col_string,firstsame_col)!=NULL)
	{
		sprintf(temp,"%c",firstsame_col);
		strcat(out_array[connection].connection_output,temp);
	}
	else
	{
		sprintf(temp,"%c",secondsame_col);
		strcat(out_array[connection].connection_output,temp);
	}
	return ;
}

/*#################### set all X for left pair ########################*/
void set_X_lf(int row,int col)
{
	int new_col;
	new_col=get_new_col(col,LEFT);
	cell_array[row][col].value='X';
	cell_array[row][new_col].value='X';
	return;
}

/*#################### save cell numbers for left pair ########################*/
void save_cellno_lf(int row,int col)
{
	int new_col;
	new_col=get_new_col(col,LEFT);
	if(cell_array[row][col].real_value=='1')
	{
		out_array[connection].cell_num_string[0]=cell_array[row][col].cell_num;
		if(cell_array[row][new_col].real_value=='1')
		{
			out_array[connection].cell_num_string[1]=cell_array[row][new_col].cell_num;
			out_array[connection].cell_num_string[2]='\0';
			return;
		}
		out_array[connection].cell_num_string[1]='\0';
	}
	return;
}
		

/*#################### Saves the key of up pair ########################*/
void save_key_up(int row,int col)
{
	int new_row;
	char firstsame_row,secondsame_row;
	char temp[2];
	new_row=get_new_row(row,UPPER);
	firstsame_row=cell_array[row][col].row_string[0];
	secondsame_row=cell_array[row][col].row_string[1];
	strcat(out_array[connection].connection_output,cell_array[row][col].col_string);
	if(strchr(cell_array[new_row][col].row_string,firstsame_row)!=NULL)
	{
		sprintf(temp,"%c",firstsame_row);
		strcat(out_array[connection].connection_output,temp);
	}
	else
	{
		sprintf(temp,"%c",secondsame_row);
		strcat(out_array[connection].connection_output,temp);
	}
	return ;
}

/*#################### set all X for Upper pair ########################*/
void set_X_up(int row,int col)
{
	int new_row;
	new_row=get_new_row(row,UPPER);
	cell_array[row][col].value='X';
	cell_array[new_row][col].value='X';
	return;
}

/*#################### save cell numbers for upper pair ########################*/
void save_cellno_up(int row,int col)
{
	int new_row;
	new_row=get_new_row(row,UPPER);
	if(cell_array[row][col].real_value=='1')
	{
		out_array[connection].cell_num_string[0]=cell_array[row][col].cell_num;
		if(cell_array[new_row][col].real_value=='1')
		{
			out_array[connection].cell_num_string[1]=cell_array[new_row][col].cell_num;
			out_array[connection].cell_num_string[2]='\0';
			return;
		}
		out_array[connection].cell_num_string[1]='\0';
	}
	return;
}


/*#################### Saves the key of right pair ########################*/
void save_key_rt(int row,int col)
{
	int new_col;
	char firstsame_col,secondsame_col;
	char temp[2];
	new_col=get_new_col(col,RIGHT);
	firstsame_col=cell_array[row][col].col_string[0];
	secondsame_col=cell_array[row][col].col_string[1];
	strcat(out_array[connection].connection_output,cell_array[row][col].row_string);
	if(strchr(cell_array[row][new_col].col_string,firstsame_col)!=NULL)
	{
		sprintf(temp,"%c",firstsame_col);
		strcat(out_array[connection].connection_output,temp);
	}
	else
	{
		sprintf(temp,"%c",secondsame_col);
		strcat(out_array[connection].connection_output,temp);
	}
	return ;
}

/*#################### set all X for right pair ########################*/
void set_X_rt(int row,int col)
{
	int new_col;
	new_col=get_new_col(col,RIGHT);
	cell_array[row][col].value='X';
	cell_array[row][new_col].value='X';
	return;
}

/*#################### save cell numbers for right pair ########################*/
void save_cellno_rt(int row,int col)
{
	int new_col;
	new_col=get_new_col(col,RIGHT);
	if(cell_array[row][col].real_value=='1')
	{
		out_array[connection].cell_num_string[0]=cell_array[row][col].cell_num;
		if(cell_array[row][new_col].real_value=='1')
		{
			out_array[connection].cell_num_string[1]=cell_array[row][new_col].cell_num;
			out_array[connection].cell_num_string[2]='\0';
			return;
		}
		out_array[connection].cell_num_string[1]='\0';
	}
	return;
}


/*#################### Saves the key of down pair ########################*/
void save_key_dn(int row,int col)
{
	int new_row;
	char firstsame_row,secondsame_row;
	char temp[2];
	new_row=get_new_row(row,LOWER);
	firstsame_row=cell_array[row][col].row_string[0];
	secondsame_row=cell_array[row][col].row_string[1];
	strcat(out_array[connection].connection_output,cell_array[row][col].col_string);
	if(strchr(cell_array[new_row][col].row_string,firstsame_row)!=NULL)
	{
		sprintf(temp,"%c",firstsame_row);
		strcat(out_array[connection].connection_output,temp);
	}
	else
	{
		sprintf(temp,"%c",secondsame_row);
		strcat(out_array[connection].connection_output,temp);
	}
	return ;
}

/*#################### set all X for DOWN pair ########################*/
void set_X_dn(int row,int col)
{
	int new_row;
	new_row=get_new_row(row,LOWER);
	cell_array[row][col].value='X';
	cell_array[new_row][col].value='X';
	return;
}

/*#################### save cell numbers for Lower pair ########################*/
void save_cellno_dn(int row,int col)
{
	int new_row;
	new_row=get_new_row(row,LOWER);
	if(cell_array[row][col].real_value=='1')
	{
		out_array[connection].cell_num_string[0]=cell_array[row][col].cell_num;
		if(cell_array[new_row][col].real_value=='1')
		{
			out_array[connection].cell_num_string[1]=cell_array[new_row][col].cell_num;
			out_array[connection].cell_num_string[2]='\0';
			return;
		}
		out_array[connection].cell_num_string[1]='\0';
	}
	return;
}
