#include "kmap_struct.h"
#include "quad_lib.h"
#include "g_library.h"

/*############ SAVES THE KEY IN  out_array FOR HOR. AND VERTICAL QUAD #############*/
void save_key_hz_vrt(int row,int col,int hr_or_vr)
{
	switch(hr_or_vr)
	{
		case HZNTL:
			strcpy(out_array[connection].connection_output,cell_array[row][col].row_string);
			break;
		case VRTCL:
			strcpy(out_array[connection].connection_output,cell_array[row][col].col_string);
			break;
	}
	return;
}


/*############ SAVES THE CELL NUMB  IN  out_array FOR HOR. AND VERTICAL QUAD #############*/
void save_cellno_hz_vrt(int row,int col,int hr_or_vr)
{
	int i,j,arr_count;
	switch(hr_or_vr)
	{
		case HZNTL:
		{
			for(j=0,arr_count=0;j<=3;j++)
			{	
				if(cell_array[row][j].real_value=='1')
				{
					out_array[connection].cell_num_string[arr_count]=cell_array[row][j].cell_num;
					arr_count++;
				}
			}
			break;
		}
		case VRTCL:
		{
			for(i=0,arr_count=0;i<=3;i++)
			{	
				if(cell_array[i][col].real_value=='1')
				{
					out_array[connection].cell_num_string[arr_count]=cell_array[i][col].cell_num;
					arr_count++;
				}
			}
			break;
		}
	}
	return;
}



/*###################### SET ALL 1s AS Xs for HOR. & VER.########################*/
void set_all_x_hz_vr(int row,int col,int hr_or_vr)
{
	int i,j;
	switch(hr_or_vr)
	{
		case HZNTL:
		{
			for(j=0;j<=3;j++)
			{
				cell_array[row][j].value='X';
			}
			break;
		}
		case VRTCL:
		{
			for(i=0;i<=3;i++)
			{
				cell_array[i][col].value='X';
			}
			break;
		}
	}
	return;
}

/*###################### Saves the key of left-down quad ######################*/
void save_key_lf_dn(int row,int col)
{
	char firstsame_col,secondsame_col,firstsame_row,secondsame_row;
	int new_row,new_col;
	char temp[2];
	new_row=get_new_row(row,LOWER);
	new_col=get_new_col(col,LEFT);
	firstsame_col=cell_array[row][col].col_string[0];
	secondsame_col=cell_array[row][col].col_string[1];
	if(strchr(cell_array[row][new_col].col_string,firstsame_col)!=NULL)
		sprintf(out_array[connection].connection_output,"%c",firstsame_col);
	else
		sprintf(out_array[connection].connection_output,"%c",secondsame_col);
	firstsame_row=cell_array[row][col].row_string[0];
	secondsame_row=cell_array[row][col].row_string[1];
	if(strchr(cell_array[new_row][col].row_string,firstsame_row)!=NULL)
	{
		sprintf(temp,"%c",firstsame_row);
		strcat(out_array[connection].connection_output,temp);
	}
	else
	{
		sprintf(temp,"%c",secondsame_row);
		strcat(out_array[connection].connection_output,temp);
	}
	return;
}

/*################# Save cell_nums of left-down quad ########################*/
void save_cellno_lf_dn(int row,int col)
{
	int new_row,new_col;
	char temp[2];
	new_row=get_new_row(row,LOWER);
	new_col=get_new_col(col,LEFT);
	strcpy(out_array[connection].cell_num_string,"");
	if(cell_array[row][col].real_value=='1')
	{
		sprintf(temp,"%c",cell_array[row][col].cell_num);
		strcat(out_array[connection].cell_num_string,temp);
	}
	if(cell_array[row][new_col].real_value=='1')
	{
		sprintf(temp,"%c",cell_array[row][new_col].cell_num);
		strcat(out_array[connection].cell_num_string,temp);
	}
	if(cell_array[new_row][new_col].real_value=='1')
	{
		sprintf(temp,"%c",cell_array[new_row][new_col].cell_num);
		strcat(out_array[connection].cell_num_string,temp);
	}	
	if(cell_array[new_row][col].real_value=='1')
	{
		sprintf(temp,"%c",cell_array[new_row][col].cell_num);
		strcat(out_array[connection].cell_num_string,temp);
	}
	return;
}


/*################# Set all 1s as Xs of left-down quad ########################*/
void set_all_x_lf_dn(int row,int col)
{
	int new_row,new_col;
	new_row=get_new_row(row,LOWER);
	new_col=get_new_col(col,LEFT);
	cell_array[row][col].value='X';
	cell_array[row][new_col].value='X';
	cell_array[new_row][new_col].value='X';
	cell_array[new_row][col].value='X';
	return;
}
	

/*###################### Saves the key of left-up quad ######################*/
void save_key_lf_up(int row,int col)
{
	char firstsame_col,secondsame_col,firstsame_row,secondsame_row;
	int new_row,new_col;
	char temp[2];
	new_row=get_new_row(row,UPPER);
	new_col=get_new_col(col,LEFT);
	firstsame_col=cell_array[row][col].col_string[0];
	secondsame_col=cell_array[row][col].col_string[1];
	if(strchr(cell_array[row][new_col].col_string,firstsame_col)!=NULL)
		sprintf(out_array[connection].connection_output,"%c",firstsame_col);
	else
		sprintf(out_array[connection].connection_output,"%c",secondsame_col);
	firstsame_row=cell_array[row][col].row_string[0];
	secondsame_row=cell_array[row][col].row_string[1];
	if(strchr(cell_array[new_row][col].row_string,firstsame_row)!=NULL)
	{
		sprintf(temp,"%c",firstsame_row);
		strcat(out_array[connection].connection_output,temp);
	}
	else
	{
		sprintf(temp,"%c",secondsame_row);
		strcat(out_array[connection].connection_output,temp);
	}
	return;
}

/*################# Save cell_nums of left-up quad ########################*/
void save_cellno_lf_up(int row,int col)
{
	int new_row,new_col;
	char temp[2];
	new_row=get_new_row(row,UPPER);
	new_col=get_new_col(col,LEFT);
	strcpy(out_array[connection].cell_num_string,"");
	if(cell_array[row][col].real_value=='1')
	{
		sprintf(temp,"%c",cell_array[row][col].cell_num);
		strcat(out_array[connection].cell_num_string,temp);
	}
	if(cell_array[row][new_col].real_value=='1')
	{
		sprintf(temp,"%c",cell_array[row][new_col].cell_num);
		strcat(out_array[connection].cell_num_string,temp);
	}
	if(cell_array[new_row][new_col].real_value=='1')
	{
		sprintf(temp,"%c",cell_array[new_row][new_col].cell_num);
		strcat(out_array[connection].cell_num_string,temp);
	}	
	if(cell_array[new_row][col].real_value=='1')
	{
		sprintf(temp,"%c",cell_array[new_row][col].cell_num);
		strcat(out_array[connection].cell_num_string,temp);
	}
	return;
}

/*################# Set all 1s as Xs of left-up quad ########################*/
void set_all_x_lf_up(int row,int col)
{
	int new_row,new_col;
	new_row=get_new_row(row,UPPER);
	new_col=get_new_col(col,LEFT);
	cell_array[row][col].value='X';
	cell_array[row][new_col].value='X';
	cell_array[new_row][new_col].value='X';
	cell_array[new_row][col].value='X';
	return;
}


/*###################### Saves the key of right-up quad ######################*/
void save_key_rt_up(int row,int col)
{
	char firstsame_col,secondsame_col,firstsame_row,secondsame_row;
	int new_row,new_col;
	char temp[2];
	new_row=get_new_row(row,UPPER);
	new_col=get_new_col(col,RIGHT);
	firstsame_col=cell_array[row][col].col_string[0];
	secondsame_col=cell_array[row][col].col_string[1];
	if(strchr(cell_array[row][new_col].col_string,firstsame_col)!=NULL)
		sprintf(out_array[connection].connection_output,"%c",firstsame_col);
	else
		sprintf(out_array[connection].connection_output,"%c",secondsame_col);
	firstsame_row=cell_array[row][col].row_string[0];
	secondsame_row=cell_array[row][col].row_string[1];
	if(strchr(cell_array[new_row][col].row_string,firstsame_row)!=NULL)
	{
		sprintf(temp,"%c",firstsame_row);
		strcat(out_array[connection].connection_output,temp);
	}
	else
	{
		sprintf(temp,"%c",secondsame_row);
		strcat(out_array[connection].connection_output,temp);
	}
	return;
}

/*################# Save cell_nums of right-up quad ########################*/
void save_cellno_rt_up(int row,int col)
{
	int new_row,new_col;
	char temp[2];
	new_row=get_new_row(row,UPPER);
	new_col=get_new_col(col,RIGHT);
	strcpy(out_array[connection].cell_num_string,"");
	if(cell_array[row][col].real_value=='1')
	{
		sprintf(temp,"%c",cell_array[row][col].cell_num);
		strcat(out_array[connection].cell_num_string,temp);
	}
	if(cell_array[row][new_col].real_value=='1')
	{
		sprintf(temp,"%c",cell_array[row][new_col].cell_num);
		strcat(out_array[connection].cell_num_string,temp);
	}
	if(cell_array[new_row][new_col].real_value=='1')
	{
		sprintf(temp,"%c",cell_array[new_row][new_col].cell_num);
		strcat(out_array[connection].cell_num_string,temp);
	}	
	if(cell_array[new_row][col].real_value=='1')
	{
		sprintf(temp,"%c",cell_array[new_row][col].cell_num);
		strcat(out_array[connection].cell_num_string,temp);
	}
	return;
}


/*################# Set all 1s as Xs of right-up quad ########################*/
void set_all_x_rt_up(int row,int col)
{
	int new_row,new_col;
	new_row=get_new_row(row,UPPER);
	new_col=get_new_col(col,RIGHT);
	cell_array[row][col].value='X';
	cell_array[row][new_col].value='X';
	cell_array[new_row][new_col].value='X';
	cell_array[new_row][col].value='X';
	return;
}



/*###################### Saves the key of right-down quad ######################*/
void save_key_rt_dn(int row,int col)
{
	char firstsame_col,secondsame_col,firstsame_row,secondsame_row;
	int new_row,new_col;
	char temp[2];
	new_row=get_new_row(row,LOWER);
	new_col=get_new_col(col,RIGHT);
	firstsame_col=cell_array[row][col].col_string[0];
	secondsame_col=cell_array[row][col].col_string[1];
	if(strchr(cell_array[row][new_col].col_string,firstsame_col)!=NULL)
		sprintf(out_array[connection].connection_output,"%c",firstsame_col);
	else
		sprintf(out_array[connection].connection_output,"%c",secondsame_col);
	firstsame_row=cell_array[row][col].row_string[0];
	secondsame_row=cell_array[row][col].row_string[1];
	if(strchr(cell_array[new_row][col].row_string,firstsame_row)!=NULL)
	{
		sprintf(temp,"%c",firstsame_row);
		strcat(out_array[connection].connection_output,temp);
	}
	else
	{
		sprintf(temp,"%c",secondsame_row);
		strcat(out_array[connection].connection_output,temp);
	}
	return;
}

/*################# Save cell_nums of right-down quad ########################*/
void save_cellno_rt_dn(int row,int col)
{
	int new_row,new_col;
	char temp[2];
	new_row=get_new_row(row,LOWER);
	new_col=get_new_col(col,RIGHT);
	strcpy(out_array[connection].cell_num_string,"");
	if(cell_array[row][col].real_value=='1')
	{
		sprintf(temp,"%c",cell_array[row][col].cell_num);
		strcat(out_array[connection].cell_num_string,temp);
	}
	if(cell_array[row][new_col].real_value=='1')
	{
		sprintf(temp,"%c",cell_array[row][new_col].cell_num);
		strcat(out_array[connection].cell_num_string,temp);
	}
	if(cell_array[new_row][new_col].real_value=='1')
	{
		sprintf(temp,"%c",cell_array[new_row][new_col].cell_num);
		strcat(out_array[connection].cell_num_string,temp);
	}	
	if(cell_array[new_row][col].real_value=='1')
	{
		sprintf(temp,"%c",cell_array[new_row][col].cell_num);
		strcat(out_array[connection].cell_num_string,temp);
	}
	return;
}


/*################# Set all 1s as Xs of right-down quad ########################*/
void set_all_x_rt_dn(int row,int col)
{
	int new_row,new_col;
	new_row=get_new_row(row,LOWER);
	new_col=get_new_col(col,RIGHT);
	cell_array[row][col].value='X';
	cell_array[row][new_col].value='X';
	cell_array[new_row][new_col].value='X';
	cell_array[new_row][col].value='X';
	return;
}
